<xsl:stylesheet version="2.0"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	
<xsl:output method="xml" indent="yes"/>

<xsl:key name="idkey" match="node" use="@id"/>

<xsl:variable name="nds">
	<xsl:for-each-group select="/osm/way/nd" group-by="@ref">
		<xsl:sort select="@ref" data-type="number"/>
		<xsl:copy-of select="key('idkey',@ref)"/>
	</xsl:for-each-group>
</xsl:variable>

<xsl:template match="/osm">
	<xsl:copy>
		<xsl:copy-of select="@*"/>
		<xsl:copy-of select="$nds"/>
		<xsl:copy-of select="way"/>
	</xsl:copy>
</xsl:template>

</xsl:stylesheet>
